# Changelog

## [2.22] - 2024-10-31
- Added EdgePort, IAS and GEANT IP products and required workflows
- Refactored pydantic models for maintainability

## [2.21] - 2024-10-22
- Fix inventory structure
- Fix the `pe_router_list` in update_sdp_single_pe
- Remove --concurrency=1 --pool=solo
- Don't fail router termination if the device doesn't exist in LibreNMS or Kentik
- Improve error handling for missing LibreNMS device in router termination
- Add moodi start and stop steps
- Add pytest-xdist for parallel test execution
- Update validate_router WF_USABLE_MAP to run validations only on "ACTIVE" routers, allowing workflows for provisioning routers.

## [2.20] - 2024-10-10
-  Fix callback step live update by bumping to orchestrator-core==2.7.6

## [2.19] - 2024-10-09
- LSO interaction rework: Skip a playbook automatically if the inventory is empty.
- Introduction of LSOState type.
- Celery: add as Executor, cleanup.
- `promote_p_to_pe` and `update_ibgp_mesh`: add conditionals to distinguish between P and PE for the iBGP/SDP updates and PE-specific functions and logic.
- Update of unit test in `test_update_ibgp_mesh`.

## [2.18] - 2024-10-01
-  Use solo pool for Celery workers

## [2.15] - 2024-09-30
- Show current license usage when updating Kentik license of a router
- Fix the bug of clearing all the AE members and creating new objects instead of updating it.
- make orchestrator-core==2.7.5

## [2.14] - 2024-09-19
- Fixes to Infoblox client.

## [2.13] - 2024-09-18
- Run cleanup at 1 AM only, not every minute between 1 and 2 AM.
- Add checklist to trunk migration and include ACTIVITY_TYPE column as discussed with SM.
- Fix SDP update logic in the promotion from P to PE.
- Update core lib to 2.7.4
- Refactor validators into a separate types module.
- Add Tier3 model for Netbox.
- Fix: Increase initial connection timeout for LibreNMS client.
- Fix: Change type from LAGMember to dict for workflow step in trunk modification
- Make celery concurrency level to 1

## [2.12] - 2024-08-22
- Add promote P to PE workflow.
- Add new cleanup task
- Rework the Kentik client
- Update documentation of services and schedules modules
- Enhanced Infoblox: Now pings all hosts, searches for all IPs, and checks for overlapping IP trunk subscriptions in allocated networks when creating a trunk.

## [2.11] - 2024-08-19
- (fix) Make LibreNMS retry when a request times out
- (fix) Adjust the mechanics of the minimum amount of links when creating an IP trunk

## [2.10] - 2024-08-06
- Update map API endpoint

## [2.9] - 2024-08-06
- IP trunk validation workflow no longer runs for Juniper-only trunks
- Automatically run pre- and post-checks when modifying an IP trunk
- Small improvements to email notifications

## [2.8] - 2024-08-01
- Reworked authentication components
- Add a task for sending email notifications in case validation workflows have failed
- Fix Netbox device type for tier 2 sites
- Add a Kentik client
- Add tasks for updating partners
- Fix a bug in IP trunk validation workflow
- Update router termination workflow
- Update `orchestrator-core` from 2.2.1 to 2.6.1

## [2.7] - 2024-07-18
- Added verification workflows.

## [2.5] - 2024-07-16
- Added import Opengear workflow.
- NAT-616
- NAT-617: Restored ISIS metric to new node
- NAT-619: Fixed BFD update logic bug

## [2.4] - 2024-06-25
- Fixed the issue with client_credentials grant type token in Authentication part.

## [2.3] - 2024-06-19
- Changed Modify IP trunk label to Modify ISIS

## [2.2] - 2024-06-18
- Fixed DNS allocation when hostname is already in use during allocation process.
- Fixed regex that validates interface names
- Changed Modify IP trunk label to Modify ISIS

## [2.1] - 2024-06-17
- Fixed tiny bugs in migrate IP trunk.

## [2.0] - 2024-05-23
- Upgraded `orchestrator-core` to version 2!
- Added Opengear products.
- Added separate imported product types for importing existing subscriptions.
- Added workflows to take imported products to their counterparts.
- Removed API endpoints for importing products, this is now CLI only.
- Add a SharePoint service that can create new checklist items.
    - Create new checklist in Router creation workflow.
    - Create new checklist when creating an IP trunk.

## [1.5] - 2024-04-22
- Added deploy TWAMP functionality.
- Made some changes on IP Trunk creation/modification workflow including:
    - Replaced `minimum link` with `number of members` in the IP trunks workflows.
    - Added a confirmation page for users to confirm the `minimum links` value.
    - Made `interface description` optional.
    - Made `GA-GID` and `GA-SID` optional.
- Added a rule to OPA policies to give access to Inventory Provider.
- Improved the codebase to include OIDC client ID in userinfo.
- Added switch, LAN switch interconnect and Pop VLAN domain models. 

## [1.1] - 2024-04-04
- Fixed the AttributeError in the migrate_iptrunk workflow.
- Improved the delete device in Netbox functionality.

## [1.0] - 2024-03-28
- PHASE 1 initial release

## [0.9] - 2024-03-20
- `migrate_iptrunk` workflow includes Ansible trunk checks.
- `create_iptrunk` and `migrate_iptrunk` now update IPAM / DNS.
- lso result step title is now always the name of the provisioning step

## [0.8] - 2024-02-28
- Add two new workflows for "activating" `Router` and `Iptrunk` products.
- Update lifecycle states for `Router` and `Iptrunk` products.
- Fix an issue in the Infoblox client when using a custom `dns_view`.

## [0.7] - 2024-02-21
- Infoblox client: added support for the `network_view` (IPAM).

## [0.6] - 2024-02-07
- Removed the import workflows from migrations.

## [0.5] - 2024-01-30
- Changed the router access ts field to FALSE in import router workfolw. 

## [0.4] - 2024-01-26
- Added Token authentication for LSO callbacks.

## [0.3] - 2024-01-23
- Fixed related to the Authentication and some small improvments.

## [0.2] - 2024-01-16
- Initial release

## [0.1] - 2023-12-04
- initial skeleton
